/*
 * ValueHolderInterface.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#include <abstraction/Value.hpp>
#include <abstraction/OperationAbstraction.hpp>

namespace abstraction {

std::shared_ptr < abstraction::Value > Value::getProxyAbstraction ( ) {
	return shared_from_this ( );
}

std::string Value::getType ( ) const {
	return ext::to_string ( getTypeIndex ( ) );
}


std::shared_ptr < abstraction::Value > Void::clone ( abstraction::TypeQualifiers::TypeQualifierSet, bool ) {
	throw std::domain_error ( "Void variables are not allowed" );
}

ext::type_index Void::getTypeIndex ( ) const {
	return ext::type_index ( typeid ( void ) );
}

abstraction::TypeQualifiers::TypeQualifierSet Void::getTypeQualifiers ( ) const {
	return abstraction::TypeQualifiers::typeQualifiers < void > ( );
}

} /* namespace abstraction */
